if select(2,UnitClass("player")) ~= "PRIEST" then return end

-- O
local barsize = {200,15}											-- С
local barpoint = {"center", UIParent, 0, -100}						-- 
local statusbartexture = "Interface\\AddOns\\spball\\statusbar"		-- statusbar
local autofade = true												-- Ƿս
local bballcolor = {151/255, 86/255, 168/255}						-- ɫ
local rballcolor = {1, 0.3, 0.6}									-- ɫ
local perbarcolor = {106/255, 90/255, 205/255}						-- ɫ

-- ²ݲҪS
local bspn = GetSpellInfo(77487)  -- Ӱ
local rspn = GetSpellInfo(95799)  -- Ӱ

local crateshadow = function(parent)
	local shadow = CreateFrame("Frame", nil, parent)
	shadow:SetPoint("TOPLEFT", -5, 5)
	shadow:SetPoint("BOTTOMRIGHT", 5, -5)
	shadow:SetFrameStrata(parent:GetFrameStrata())
	shadow:SetFrameLevel(0)
	shadow:SetBackdrop({edgeFile = "Interface\\addons\\spball\\glow", edgeSize = 5,})
	shadow:SetBackdropBorderColor(0,0,0)
end

local bar = CreateFrame("Frame", "spbar", UIParent)
bar:SetSize(unpack(barsize))
bar:SetPoint(unpack(barpoint))
bar:SetFrameStrata("MEDIUM")
bar:SetFrameLevel(2)
bar:SetBackdrop({
	bgFile = "Interface\\Buttons\\WHITE8x8",
	edgeFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 1,})
bar:SetBackdropColor( .1, .1, .1, .6)
bar:SetBackdropBorderColor(0, 0, 0)
crateshadow(bar)

local bbar = CreateFrame("Frame", nil, bar)
for i = 1, 3 do
	bbar[i] = CreateFrame("StatusBar", nil, bbar)
	bbar[i]:SetSize((bar:GetWidth()-4)/3, bar:GetHeight()/3*2-1)
	bbar[i]:SetStatusBarTexture(statusbartexture)
	bbar[i]:GetStatusBarTexture():SetHorizTile(false)
	bbar[i]:SetStatusBarColor(unpack(bballcolor))
	bbar[i]:SetAlpha(.15)

	if i == 1 then
		bbar[i]:SetPoint("TOPLEFT", bar, 1, -1)
	else
		bbar[i]:SetPoint("LEFT", bbar[i-1], "RIGHT", 1, 0)
	end
end

local function tex(p,w,h)
	local f = p:CreateTexture(nil, "OVERLAY")
	f:SetTexture("Interface\\Buttons\\WHITE8x8")
	f:SetSize(w,h)
	f:SetVertexColor(0,0,0)
	
	return f
end

bar.ct = tex(bar,bar:GetWidth(),1)
bar.ct:SetPoint("TOPLEFT",bbar[1],"BOTTOMLEFT",-1,0)

bbar.ct1 = tex(bar,1,bbar[1]:GetHeight()+1)
bbar.ct1:SetPoint("LEFT",bbar[1],"RIGHT",0,1)

bbar.ct2 = tex(bar,1,bbar[2]:GetHeight()+1)
bbar.ct2:SetPoint("LEFT",bbar[2],"RIGHT",0,1)

local rbar = CreateFrame("StatusBar", "rstatusbar", bar)
rbar:SetSize(bar:GetWidth()-2, bar:GetHeight()/3-2)
rbar:SetStatusBarTexture(statusbartexture)
rbar:GetStatusBarTexture():SetHorizTile(false)
rbar:SetStatusBarColor(unpack(rballcolor))
rbar:SetPoint("TOPLEFT", bbar[1], "BOTTOMLEFT", 0, -1)
rbar:SetMinMaxValues(0, 15)
rbar:SetValue(0)

rbar.bg = rbar:CreateTexture(nil, "BORDER")
rbar.bg:SetAllPoints(rbar)
rbar.bg:SetTexture("Interface\\Buttons\\WHITE8x8")
rbar.bg:SetVertexColor(unpack(rballcolor))
rbar.bg:SetAlpha(.15)

rbar.mb1 = tex(rbar,1,rbar:GetHeight()+1)
rbar.mb1:SetPoint("TOPRIGHT", -rbar:GetWidth()/15*6.5, 0)

rbar.mb2 = tex(rbar,1,rbar:GetHeight()+1)
rbar.mb2:SetPoint("TOPLEFT", rbar:GetWidth()/15*1.5, 0)

local function UpdateRed(self,elapsed)
	-- t򲿷
	local expirationtime = select(7,UnitBuff("player", rspn))
	if expirationtime then
		timer = expirationtime - GetTime()
	else
		timer = 0
	end
	self:SetValue(timer)
end

bar:SetAlpha(autofade and .3 or 1)

local function GetTelent()
   local points = {}
   local talent = 1
   for i=1,3 do
      _,_,_,_,points[i] = GetTalentTabInfo(i,false,false,GetActiveTalentGroup(false,false));
      if points[i] > points[talent] then talent = i end
   end
   return talent
end

local function OnEvent(self,event)
	-- 򲿷
	rank = select(4,UnitBuff("player", bspn))
	if rank then
		for i = 1, rank do
			bbar[i]:SetAlpha(1)
		end
	else
		for i = 1, 3 do
			bbar[i]:SetAlpha(.15)
		end
	end
	rbar:SetScript("OnUpdate", UpdateRed)
	
	if GetTelent() ~= 3 then return end
	
	if autofade == true then
		if event == "PLAYER_REGEN_DISABLED" then
			self:SetAlpha(1)
		elseif event == "PLAYER_REGEN_ENABLED" then
			UIFrameFadeIn(self, 0.2, self:GetAlpha(), 0.3)
		end
	end
end

bar:RegisterEvent("PLAYER_ENTERING_WORLD")
bar:RegisterEvent("UNIT_AURA")
bar:RegisterEvent("PLAYER_REGEN_DISABLED")
bar:RegisterEvent("PLAYER_REGEN_ENABLED")
bar:SetScript("OnEvent", OnEvent)

-- Ӱħ
local petbar = CreateFrame("Frame", nil, UIParent)
petbar:SetSize(bar:GetWidth(),bar:GetHeight()/3)
petbar:SetPoint("BOTTOM", bar, "TOP", 0, 5)
petbar:SetFrameStrata("MEDIUM")
petbar:SetFrameLevel(2)
petbar:SetBackdrop({
	bgFile = "Interface\\Buttons\\WHITE8x8",
	edgeFile = "Interface\\Buttons\\WHITE8x8", edgeSize = 1,})
petbar:SetBackdropColor( .1, .1, .1, .6)
petbar:SetBackdropBorderColor(0, 0, 0)
crateshadow(petbar)

local psbar = CreateFrame("StatusBar", nil, petbar)
psbar:SetSize(petbar:GetWidth()-2, petbar:GetHeight()-2)
psbar:SetStatusBarTexture(statusbartexture)
psbar:GetStatusBarTexture():SetHorizTile(false)
psbar:SetStatusBarColor(unpack(perbarcolor))
psbar:SetPoint("LEFT", petbar, 1, 0)
psbar:SetMinMaxValues(0, 15000)
psbar:SetValue(0)

psbar.bg = psbar:CreateTexture(nil, "BORDER")
psbar.bg:SetAllPoints(psbar)
psbar.bg:SetTexture("Interface\\Buttons\\WHITE8x8")
psbar.bg:SetVertexColor(unpack(perbarcolor))
psbar.bg:SetAlpha(.15)

petbar:Hide()
local function UpdatePet(self,elapsed)
	if GetPetTimeRemaining() and GetPetTimeRemaining() < 15000 then
		psbar:SetValue(GetPetTimeRemaining())
	else
		psbar:SetValue(0)
	end
end
local pethelper = CreateFrame("Frame", nil, UIParent)
pethelper:SetScript("OnUpdate", function()
	if UnitExists("pet") then
		petbar:Show()
	else
		petbar:Hide()
	end
end)

petbar:SetScript("OnUpdate",UpdatePet)

local helper = CreateFrame("Frame", nil, UIParent)
helper:RegisterEvent("PLAYER_ENTERING_WORLD")
helper:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
helper:RegisterEvent("CONFIRM_TALENT_WIPE")
helper:RegisterEvent("PLAYER_TALENT_UPDATE")
helper:SetScript("OnEvent",function()
	if GetTelent() ~= 3 then
		bar:Hide()
		petbar:Hide()
	else
		bar:Show()
		petbar:Show()
	end
end)